package kr.co.vividnext.sodalive.live.recommend

import kr.co.vividnext.sodalive.member.Member
import org.springframework.stereotype.Service

@Service
class LiveRecommendService(private val repository: LiveRecommendRepository) {

    fun getRecommendLive(member: Member): List<GetRecommendLiveResponse> {
        return repository.getRecommendLive(
            memberId = member.id!!,
            isAdult = member.auth != null
        )
    }

    fun getRecommendChannelList(member: Member): List<GetRecommendChannelResponse> {
        val onAirChannelList = repository.getOnAirRecommendChannelList(member.id!!, isAdult = member.auth != null)

        if (onAirChannelList.size >= 20) {
            return onAirChannelList
        }

        val onAirCreatorIdList = onAirChannelList.asSequence()
            .map { it.creatorId }
            .toList()

        val notOnAirCreatorList = repository.getRecommendChannelList(
            member.id!!,
            withOutCreatorList = onAirCreatorIdList,
            limit = (20 - onAirChannelList.size).toLong()
        )

        return onAirChannelList + notOnAirCreatorList
    }
}
